package example.ve.swing;

import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.DefaultListModel;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.ListModel;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;

public class DatabaseViewerGUI extends JFrame {

    private javax.swing.JPanel jContentPane = null;

    private javax.swing.JMenuBar mainMenuBar = null;
    private javax.swing.JMenu fileMenu = null;
    private javax.swing.JMenu helpMenu = null;
    private javax.swing.JMenuItem exitMenuItem = null;
    private javax.swing.JMenuItem aboutMenuItem = null;
    private javax.swing.JPanel headerPanel = null;
    private javax.swing.JLabel jLabel = null;
    private javax.swing.JPanel statusPanel = null;
    private javax.swing.JLabel statusLabel = null;
    private javax.swing.JPanel tableNamePanel = null;
    private javax.swing.JList tableNameList = null;
    private javax.swing.JLabel jLabel2 = null;
    private javax.swing.JScrollPane jScrollPane = null;
    private javax.swing.JTable resultSetTable = null;
    private javax.swing.JSplitPane jSplitPane = null;
    private javax.swing.JComboBox databaseNameComboBox = null;
    private ComboBoxModel _comboBoxModel = new DefaultComboBoxModel();
    private ListModel _listModel = new DefaultListModel();
    private TableModel _tableModel = new DefaultTableModel();

    /**
     * This is the default constructor
     */
    public DatabaseViewerGUI() {
        super();
        initialize();
    }
    public DatabaseViewerGUI(DatabaseViewerModel model) {
        _comboBoxModel = model.getDatabaseNameComboBoxModel();
        _listModel = model.getTableNameListModel();
        _tableModel = model.getDatabaseTableModel();
        initialize();
    }

    /**
     * @return
     */
    public ComboBoxModel getComboBoxModel() {
        return _comboBoxModel;
    }

    /**
     * @return
     */
    public ListModel getListModel() {
        return _listModel;
    }

    /**
     * @return
     */
    public TableModel getTableModel() {
        return _tableModel;
    }
    /**
     * This method initializes this
     * 
     * @return void
     */
    private void initialize() {
        this.setSize(509, 343);
        this.setContentPane(getJContentPane());
        this.setJMenuBar(getMainMenuBar());
        this.setTitle("Database Viewer");
        this.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
    }
    /**
     * This method initializes jContentPane
     * 
     * @return javax.swing.JPanel
     */
    private javax.swing.JPanel getJContentPane() {
        if (jContentPane == null) {
            jContentPane = new javax.swing.JPanel();
            jContentPane.setLayout(new java.awt.BorderLayout());
            jContentPane.add(getStatusPanel(), java.awt.BorderLayout.SOUTH);
            jContentPane.add(getHeaderPanel(), java.awt.BorderLayout.NORTH);
            jContentPane.add(getJSplitPane(), java.awt.BorderLayout.CENTER);
        }
        return jContentPane;
    }
    /**
     * This method initializes mainMenuBar
     * 
     * @return javax.swing.JMenuBar
     */
    private javax.swing.JMenuBar getMainMenuBar() {
        if (mainMenuBar == null) {
            mainMenuBar = new javax.swing.JMenuBar();
            mainMenuBar.add(getFileMenu());
            mainMenuBar.add(getHelpMenu());
        }
        return mainMenuBar;
    }
    /**
     * This method initializes fileMenu
     * 
     * @return javax.swing.JMenu
     */
    private javax.swing.JMenu getFileMenu() {
        if (fileMenu == null) {
            fileMenu = new javax.swing.JMenu();
            fileMenu.add(getExitMenuItem());
            fileMenu.setText("File");
            fileMenu.setMnemonic(java.awt.event.KeyEvent.VK_F);
        }
        return fileMenu;
    }
    /**
     * This method initializes helpMenu
     * 
     * @return javax.swing.JMenu
     */
    private javax.swing.JMenu getHelpMenu() {
        if (helpMenu == null) {
            helpMenu = new javax.swing.JMenu();
            helpMenu.add(getAboutMenuItem());
            helpMenu.setText("Help");
            helpMenu.setMnemonic(java.awt.event.KeyEvent.VK_H);
        }
        return helpMenu;
    }
    /**
     * This method initializes exitMenuItem
     * 
     * @return javax.swing.JMenuItem
     */
    private javax.swing.JMenuItem getExitMenuItem() {
        if (exitMenuItem == null) {
            exitMenuItem = new javax.swing.JMenuItem();
            exitMenuItem.setText("Exit");
            exitMenuItem.setMnemonic(java.awt.event.KeyEvent.VK_X);
            exitMenuItem
                .addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                    System.exit(0);
                }
            });
        }
        return exitMenuItem;
    }
    /**
     * This method initializes aboutMenuItem
     * 
     * @return javax.swing.JMenuItem
     */
    private javax.swing.JMenuItem getAboutMenuItem() {
        if (aboutMenuItem == null) {
            aboutMenuItem = new javax.swing.JMenuItem();
            aboutMenuItem.setText("About");
            aboutMenuItem.setMnemonic(java.awt.event.KeyEvent.VK_A);
            aboutMenuItem
                .addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                    JOptionPane.showMessageDialog(
                        DatabaseViewerGUI.this,
                        "<html><center>Database Viewer<center><br>An example using the Eclipse Visual Editor.</html>");
                }
            });
        }
        return aboutMenuItem;
    }
    /**
     * This method initializes headerPanel
     * 
     * @return javax.swing.JPanel
     */
    private javax.swing.JPanel getHeaderPanel() {
        if (headerPanel == null) {
            headerPanel = new javax.swing.JPanel();
            headerPanel.setLayout(new java.awt.BorderLayout());
            headerPanel.add(getJLabel(), java.awt.BorderLayout.WEST);
            headerPanel.add(
                getDatabaseNameComboBox(),
                java.awt.BorderLayout.CENTER);
            headerPanel.setBorder(
                javax.swing.BorderFactory.createEtchedBorder(
                    javax.swing.border.EtchedBorder.LOWERED));
        }
        return headerPanel;
    }
    /**
     * This method initializes jLabel
     * 
     * @return javax.swing.JLabel
     */
    private javax.swing.JLabel getJLabel() {
        if (jLabel == null) {
            jLabel = new javax.swing.JLabel();
            jLabel.setText("Database name:");
        }
        return jLabel;
    }
    /**
     * This method initializes statusPanel
     * 
     * @return javax.swing.JPanel
     */
    private javax.swing.JPanel getStatusPanel() {
        if (statusPanel == null) {
            statusPanel = new javax.swing.JPanel();
            java.awt.FlowLayout layFlowLayout1 = new java.awt.FlowLayout();
            layFlowLayout1.setAlignment(java.awt.FlowLayout.LEFT);
            statusPanel.setLayout(layFlowLayout1);
            statusPanel.add(getStatusLabel(), null);
            statusPanel.setBorder(
                javax.swing.BorderFactory.createEtchedBorder(
                    javax.swing.border.EtchedBorder.LOWERED));
        }
        return statusPanel;
    }
    /**
     * This method initializes statusLabel
     * 
     * @return javax.swing.JLabel
     */
    private javax.swing.JLabel getStatusLabel() {
        if (statusLabel == null) {
            statusLabel = new javax.swing.JLabel();
            statusLabel.setText("Status: 5 rows returned.");
        }
        return statusLabel;
    }
    /**
     * This method initializes tableNamePanel
     * 
     * @return javax.swing.JPanel
     */
    private javax.swing.JPanel getTableNamePanel() {
        if (tableNamePanel == null) {
            tableNamePanel = new javax.swing.JPanel();
            tableNamePanel.setLayout(new java.awt.BorderLayout());
            tableNamePanel.add(getJLabel2(), java.awt.BorderLayout.NORTH);
            tableNamePanel.add(
                getTableNameList(),
                java.awt.BorderLayout.CENTER);
        }
        return tableNamePanel;
    }
    /**
     * This method initializes tableNameList
     * 
     * @return javax.swing.JList
     */
    private javax.swing.JList getTableNameList() {
        if (tableNameList == null) {
            tableNameList = new javax.swing.JList();
            tableNameList.setSelectionMode(
                javax.swing.ListSelectionModel.SINGLE_SELECTION);
            tableNameList.setModel(getListModel());
        }
        return tableNameList;
    }
    /**
     * This method initializes jLabel2
     * 
     * @return javax.swing.JLabel
     */
    private javax.swing.JLabel getJLabel2() {
        if (jLabel2 == null) {
            jLabel2 = new javax.swing.JLabel();
            jLabel2.setText("Table Names");
            jLabel2.setBorder(
                javax.swing.BorderFactory.createBevelBorder(
                    javax.swing.border.BevelBorder.RAISED));
        }
        return jLabel2;
    }
    /**
     * This method initializes resultSetTable
     * 
     * @return javax.swing.JTable
     */
    private javax.swing.JTable getResultSetTable() {
        if (resultSetTable == null) {
            resultSetTable = new javax.swing.JTable();
            resultSetTable.setModel(getTableModel());
        }
        return resultSetTable;
    }
    /**
     * This method initializes jScrollPane
     * 
     * @return javax.swing.JScrollPane
     */
    private javax.swing.JScrollPane getJScrollPane() {
        if (jScrollPane == null) {
            jScrollPane = new javax.swing.JScrollPane();
            jScrollPane.setViewportView(getResultSetTable());
        }
        return jScrollPane;
    }
    /**
     * This method initializes jSplitPane
     * 
     * @return javax.swing.JSplitPane
     */
    private javax.swing.JSplitPane getJSplitPane() {
        if (jSplitPane == null) {
            jSplitPane = new javax.swing.JSplitPane();
            jSplitPane.setLeftComponent(getTableNamePanel());
            jSplitPane.setRightComponent(getJScrollPane());
            jSplitPane.setDividerSize(5);
            jSplitPane.setDividerLocation(125);
        }
        return jSplitPane;
    }
    /**
     * This method initializes databaseNameComboBox
     * 
     * @return javax.swing.JComboBox
     */
    private javax.swing.JComboBox getDatabaseNameComboBox() {
        if (databaseNameComboBox == null) {
            databaseNameComboBox = new javax.swing.JComboBox();
            databaseNameComboBox.setModel(getComboBoxModel());
        }
        return databaseNameComboBox;
    }
} //  @jve:visual-info  decl-index=0 visual-constraint="19,-41"
