/**
 * @(#)SearchServlet.java 
 *
 * Copyright (c) 2004 EinTech, Inc. All Rights Reserved.
 *
 * EinTech, Inc. MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE
 * SUITABILITY OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT
 * NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR
 * A PARTICULAR PURPOSE, OR NON-INFRINGEMENT. EinTech, Inc. SHALL
 * NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF
 * USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * But, what the hey, enjoy it anyway...!  :)
 */
package kickstart.j2ee.servlet;

import java.io.IOException;
import java.util.Hashtable;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author carlos
 * 
 */
public class SearchServlet extends HttpServlet {

    private CustomerSearchService _searchService = new CustomerSearchService();

    /**
     * The doPost method of the servlet. <br>
     * 
     * This method is called when a form has its tag value method equals to
     * post.
     * 
     * @param request
     *            the request send by the client to the server
     * @param response
     *            the response send by the server to the client
     * @throws ServletException
     *             if an error occurred
     * @throws IOException
     *             if an error occurred
     */
    public void doPost(
        HttpServletRequest request,
        HttpServletResponse response)
        throws ServletException, IOException {

        CustomerSearchForm form = new CustomerSearchForm();
        String phoneNumber = request.getParameter("phoneNumber");
        form.setPhoneNumber(phoneNumber);
        boolean isValid = form.validate();
        if (isValid) {
            Hashtable info = _searchService.searchUsing(phoneNumber);

            request.setAttribute("results", info);
        } else {
            request.setAttribute("errormsg", "Please enter a phone number.");
        }

        getServletContext().getRequestDispatcher("/results.jsp").forward(
            request,
            response);
    }

}
